## nwchem 7.2.3

=== pario/CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: CMake build for GA. Only MPI-based runtimes are supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

# -------------------------------------------------------------
# PARIO header installation
# -------------------------------------------------------------

if (ENABLE_FORTRAN)
  set(DRA_FORTRAN_HEADERS
      dra/dra.fh
      dra/draf2c.h)
  set(DRA_FORTRAN_FILES
      dra/fortran.c)
  set(EAF_FORTRAN_HEADERS
      eaf/eaf.fh)
  set(EAF_FORTRAN_FILES
      eaf/eaf_f2c.c)
  set(SF_FORTRAN_HEADERS
      sf/sf.fh
      sf/sff2c.h)
  set(SF_FORTRAN_FILES
      sf/sf_fortran.c)
endif()

set(DRA_HEADERS
  dra/dra.h
#  dra/buffers.h
#  dra/drap.h
  ${DRA_FORTRAN_HEADERS}
)

set(EAF_HEADERS
  eaf/eaf.h
#  eaf/eafP.h
  ${EAF_FORTRAN_HEADERS}
)

set(ELIO_HEADERS
   elio/elio.h
   elio/chemio.h
#   elio/eliop.h
#   elio/pablo.h
)

set(SF_HEADERS
    sf/sf.h
    sf/coms.h
    ${SF_FORTRAN_HEADERS}
)

install (FILES
  ${DRA_HEADERS}
  ${EAF_HEADERS}
  ${ELIO_HEADERS}
  ${SF_HEADERS}
  DESTINATION include/ga
)

# -------------------------------------------------------------
#  PARIO executable files
# -------------------------------------------------------------

set(DRA_FILES
    dra/capi.c
    dra/disk.arrays.c
    dra/disk.param.c
    dra/env.c
    dra/buffers.c
    dra/fortran.c
    # dra/global.unsup.c
    dra/patch.util.c
    # dra/util.c
    ${DRA_FORTRAN_FILES}
)

set(EAF_FILES
    eaf/eaf.c
    eaf/eaf_f2c.c
    ${EAF_FORTRAN_FILES}
)

set(ELIO_FILES
    elio/elio.c
    elio/stat.c
)

set(SF_FILES
     sf/shared.files.c
     sf/sf_capi.c
     sf/sf_fortran.c
     ${SF_FORTRAN_FILES}
)

# -------------------------------------------------------------
# PARIO library installation
# -------------------------------------------------------------

set(PARIO_INC_DIRS  ${CMAKE_CURRENT_SOURCE_DIR}
                    ${CMAKE_CURRENT_BINARY_DIR}
                    ${PROJECT_BINARY_DIR}
                    ${CMAKE_CURRENT_SOURCE_DIR}/dra
                    ${CMAKE_CURRENT_SOURCE_DIR}/eaf
                    ${CMAKE_CURRENT_SOURCE_DIR}/elio
                    ${CMAKE_CURRENT_SOURCE_DIR}/sf
                    ${PROJECT_BINARY_DIR}/gaf2c
                    ${PROJECT_SOURCE_DIR}/ma
                    ${PROJECT_BINARY_DIR}/ma
                    ${PROJECT_SOURCE_DIR}/global/src)

add_library(sf OBJECT ${SF_FILES})
add_library(dra OBJECT ${DRA_FILES})
add_library(eaf OBJECT ${EAF_FILES})
add_library(elio OBJECT ${ELIO_FILES})

target_include_directories(sf   BEFORE PRIVATE ${PARIO_INC_DIRS})
target_include_directories(dra  BEFORE PRIVATE ${PARIO_INC_DIRS})
target_include_directories(eaf  BEFORE PRIVATE ${PARIO_INC_DIRS})
target_include_directories(elio BEFORE PRIVATE ${PARIO_INC_DIRS})

if (ENABLE_FORTRAN)
  add_dependencies(sf GenerateConfigFH)
  add_dependencies(dra GenerateConfigFH)
  add_dependencies(eaf GenerateConfigFH)
  add_dependencies(elio GenerateConfigFH)
endif()

=== ga++/src/CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: implements a primative CMake build that can be used to build
#              GA on Windows-based systems. Only MPI-based runtimes are
#              supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

# -------------------------------------------------------------
# GA++ header installation
# -------------------------------------------------------------

set(GAXX_HEADERS
  ga++.h
  GAServices.h
  GlobalArray.h
  init_term.h
  PGroup.h
  services.h
)

install (FILES
  ${GAXX_HEADERS}
  DESTINATION include/ga
)

# -------------------------------------------------------------
# GA++ library installation
# -------------------------------------------------------------

add_library(ga++
  GAServices.cc
  GlobalArray.cc
  init_term.cc
  overload.cc
  PGroup.cc
  services.cc
)

target_include_directories(ga++ BEFORE PRIVATE 
                    ${CMAKE_CURRENT_BINARY_DIR}
                    ${PROJECT_SOURCE_DIR}/global/src
                    ${PROJECT_SOURCE_DIR}/global/testing
                    ${PROJECT_SOURCE_DIR}/ma
                    ${PROJECT_BINARY_DIR}/ma
                    ${PROJECT_BINARY_DIR}/gaf2c
                    ${PROJECT_BINARY_DIR})

target_link_libraries(ga++)

install (TARGETS
  ga++
  DESTINATION lib
)

=== global/src/CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: CMake build for GA. Only MPI-based runtimes are supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

if (ENABLE_FORTRAN)
  set(GA_FORTRAN_INTERFACE_C_FILES
    fapi.c
  )
  set(GA_FORTRAN_INTERFACE_H_FILES
    cnames.h
    ${CMAKE_CURRENT_BINARY_DIR}/global.fh
  )
  set (GA_FORTRAN_INTERFACE_F_FILES
    complex.F
  )
endif()

if (ENABLE_SCALAPACK)
  set (GA_FORTRAN_INTERFACE_H_FILES
       ${GA_FORTRAN_INTERFACE_H_FILES} scalapack.fh)
  set (GA_FORTRAN_INTERFACE_F_FILES
       ${GA_FORTRAN_INTERFACE_F_FILES} scalapack.F)
  set (GA_C_SCALAPACK_WRAPPER ga_diag_seqc.c)
endif()

if (ENABLE_FORTRAN)
  #if (HAVE_LAPACK OR ENABLE_EISPACK)
  set (GA_FORTRAN_INTERFACE_F_FILES
        ${GA_FORTRAN_INTERFACE_F_FILES} ga_diag_seq.F)
  set (GA_FORTRAN_H_FILES ga-mpi.fh)
endif()

set(target_libraries
    ma
    elio
    dra
    eaf
    sf)

set(WAPI_FILES
  ga-wapi.h
  ga-wapidefs.h
)

set(GA_FILES
  base.c
  onesided.c
  collect.c
  ghosts.c
  capi.c
  fapi.c
  datatypes.c
  decomp.c
  DP.c
  elem_alg.c
  ga_diag_seqc.c
  ga_malloc.c
  ga_profile.c
  ga_solve_seq.c
  ga_symmetr.c
  ga_trace.c
  global.nalg.c
  global.npatch.c
  global.periodic.c
  global.util.c
  hsort.scat.c
  iterator.c
  matmul.c
  matrix.c
  nbutil.c
  peigstubs.c
  sclstubs.c
  select.c
  sparse.c
  ${GA_FORTRAN_INTERFACE_C_FILES}
  ${GA_FORTRAN_INTERFACE_F_FILES}
)

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/ga-wapi.h
  COMMAND ${CMAKE_COMMAND} -D INPUT:PATH="${CMAKE_CURRENT_SOURCE_DIR}/ga-papi.h" -D OUTPUT:PATH="${CMAKE_CURRENT_BINARY_DIR}/ga-wapi.h" -P ${PROJECT_SOURCE_DIR}/tools/ga_papi_to_wapi.cmake
  DEPENDS ga-papi.h
)

add_custom_command(
  OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/ga-wapidefs.h
  COMMAND ${CMAKE_COMMAND} -D INPUT:PATH="${CMAKE_CURRENT_SOURCE_DIR}/ga-papi.h" -D OUTPUT:PATH="${CMAKE_CURRENT_BINARY_DIR}/ga-wapidefs.h" -P ${PROJECT_SOURCE_DIR}/tools/ga_papi_to_wapidefs.cmake
  DEPENDS ga-papi.h
)

add_library(ga_src OBJECT
  ${CMAKE_CURRENT_BINARY_DIR}/ga-wapi.h
  ${CMAKE_CURRENT_BINARY_DIR}/ga-wapidefs.h
  ${GA_FILES}
)

target_include_directories(ga_src BEFORE PRIVATE
                    ${CMAKE_CURRENT_SOURCE_DIR}
                    ${PROJECT_BINARY_DIR}/gaf2c
                    ${PROJECT_SOURCE_DIR}/ma
                    ${PROJECT_BINARY_DIR}/ma
                    ${PROJECT_SOURCE_DIR}/comex/src-armci
                    #${PROJECT_SOURCE_DIR}/tcgmsg
                    ${PROJECT_SOURCE_DIR}/LinAlg/lapack+blas
                    ${CMAKE_CURRENT_BINARY_DIR}
                    ${PROJECT_BINARY_DIR}
)

if(ENABLE_FORTRAN)
  add_dependencies(ga_src gaf2c)
endif()

# -------------------------------------------------------------
# Global Arrays header installation
# -------------------------------------------------------------
install(FILES
#  abstract_ops.h
#  base.h
#  cnames.h
  gacommon.h
#  gaconfig.h
  ga.h
  ga-mpi.h
  ga-papi.h
#  ga_profile.h
#  ga-wapidefs.h
  ${CMAKE_CURRENT_BINARY_DIR}/ga-wapi.h
#  global.h
#  globalp.h
#  matmul.h
  ${GA_FORTRAN_H_FILES}
  ${GA_FORTRAN_INTERFACE_H_FILES}
  DESTINATION include/ga
)

=== global/testing/CMakeLists.txt ===
#
# module: CMakeLists.txt
# author: Bruce Palmer
# description: CMake build for GA. Only MPI-based runtimes are supported.
# 
# DISCLAIMER
#
# This material was prepared as an account of work sponsored by an
# agency of the United States Government.  Neither the United States
# Government nor the United States Department of Energy, nor Battelle,
# nor any of their employees, MAKES ANY WARRANTY, EXPRESS OR IMPLIED, OR
# ASSUMES ANY LEGAL LIABILITY OR RESPONSIBILITY FOR THE ACCURACY,
# COMPLETENESS, OR USEFULNESS OF ANY INFORMATION, APPARATUS, PRODUCT,
# SOFTWARE, OR PROCESS DISCLOSED, OR REPRESENTS THAT ITS USE WOULD NOT
# INFRINGE PRIVATELY OWNED RIGHTS.
#
#
# ACKNOWLEDGMENT
#
# This software and its documentation were produced with United States
# Government support under Contract Number DE-AC06-76RLO-1830 awarded by
# the United States Department of Energy.  The United States Government
# retains a paid-up non-exclusive, irrevocable worldwide license to
# reproduce, prepare derivative works, perform publicly and display
# publicly by or for the US Government, including the right to
# distribute to other US Government contractors.
#
# -*- mode: cmake -*-
# -------------------------------------------------------------
# file: CMakeLists.txt
# -------------------------------------------------------------

include_directories(BEFORE 
  ${PROJECT_SOURCE_DIR}/global/src
  ${PROJECT_BINARY_DIR}/global/src
  ${PROJECT_SOURCE_DIR}/ma 
  ${PROJECT_BINARY_DIR}/ma
  ${PROJECT_BINARY_DIR}/gaf2c
  ${PROJECT_SOURCE_DIR}/comex/src-armci
  # ${PROJECT_SOURCE_DIR}/tcgmsg
  ${PROJECT_SOURCE_DIR}/LinAlg/lapack+blas
  ${PROJECT_SOURCE_DIR}/global/testing
  ${PROJECT_BINARY_DIR})

# -------------------------------------------------------------
# Build test executables
# -------------------------------------------------------------
add_executable (big.x big.c util.c)
add_executable (elempatch.x elempatch.c util.c)
add_executable (ga-mpi.x ga-mpi.c util.c)
add_executable (gatscat.x gatscat.c util.c)
add_executable (getmem.x getmem.c util.c)
#add_executable (ipc.clean.x ipc.clean.c util.c)
add_executable (lock.x lock.c util.c)
add_executable (mtest.x mtest.c util.c)
if (LAPACK_FOUND)
  add_executable (ga_lu.x ga_lu.c util.c)
endif()

set(TEST_NPROCS_1 1)
set(TEST_NPROCS_2 2)
set(TEST_NPROCS_4 4)
if(MPI_PR) 
  set(TEST_NPROCS_1 2)
  set(TEST_NPROCS_2 3)
  set(TEST_NPROCS_4 5)
endif()

# This test uses random() and srandom() which are not available on
# Windoze
if (NOT MSVC)
   add_executable (mulmatpatchc.x mulmatpatchc.c util.c)
   ga_add_parallel_test(mulmatpatchc mulmatpatchc.x ${TEST_NPROCS_1})
endif (NOT MSVC)
add_executable (normc.x normc.c util.c)
#FIXME:Works upto 10 ranks
ga_add_parallel_test(normc normc.x ${TEST_NPROCS_4}) 
add_executable (ntestc.x ntestc.c)
ga_add_parallel_test(ntestc ntestc.x)
add_executable (ntestfc.x ntestfc.c)
ga_add_parallel_test(ntestfc ntestfc.x)
add_executable (packc.x packc.c util.c)
ga_add_parallel_test(packc packc.x)
add_executable (patch_enumc.x patch_enumc.c util.c)
ga_add_parallel_test(patch_enumc patch_enumc.x)
add_executable (perf2.x perf2.c util.c)
ga_add_parallel_test(perf2 perf2.x)
add_executable (print.x print.c util.c)
ga_add_parallel_test(print print.x ${TEST_NPROCS_4})
add_executable (scan_addc.x scan_addc.c util.c)
ga_add_parallel_test(scan_addc scan_addc.x)
add_executable (scan_copyc.x scan_copyc.c util.c)
ga_add_parallel_test(scan_copyc scan_copyc.x)
add_executable (simple_groups_commc.x simple_groups_commc.c util.c)
ga_add_parallel_test(simple_groups_commc simple_groups_commc.x)
#add_executable (sprsmatvec.x sprsmatvec.c util.c)
add_executable (testc.x testc.c util.c)
ga_add_parallel_test(testc testc.x)
add_executable (testmatmultc.x testmatmultc.c util.c)
ga_add_parallel_test(testmatmultc testmatmultc.x)
add_executable (testmult.x testmult.c util.c)
ga_add_parallel_test(testmult testmult.x)
add_executable (testmultrect.x testmultrect.c util.c)
ga_add_parallel_test(testmultrect testmultrect.x)
add_executable (unpackc.x unpackc.c util.c)
ga_add_parallel_test(unpack unpackc.x)
if (ENABLE_FORTRAN)
  add_executable (bin.x bin.F ffflush.F)
  ga_add_parallel_test(bin bin.x ${TEST_NPROCS_4})
#  add_executable (blktest.x blktest.F ffflush.F)
  add_executable (d2test.x d2test.F ffflush.F util.c)
  ga_add_parallel_test(d2test d2test.x)
  add_executable (g2test.x g2test.F ffflush.F util.c)
  ga_add_parallel_test(g2test g2test.x)
  add_executable (g3test.x g3test.F ffflush.F util.c)
  ga_add_parallel_test(g3test g3test.x)
  add_executable (ga_shift.x ga_shift.F ffflush.F)
  ga_add_parallel_test(ga_shift ga_shift.x)
  add_executable (ghosts.x ghosts.F ffflush.F util.c)
  ga_add_parallel_test(ghosts ghosts.x)
  add_executable (jacobi.x jacobi.F ffflush.F)
  ga_add_parallel_test(jacobi jacobi.x)
#  add_executable (merge.x merge.F ffflush.F)
  add_executable (mir_perf1.x mir_perf1.F ffflush.F util.c)
  ga_add_parallel_test(mir_perf1 mir_perf1.x ${TEST_NPROCS_4})
  add_executable (mir_perf2.x mir_perf2.F ffflush.F util.c)
  ga_add_parallel_test(mir_perf2 mir_perf2.x ${TEST_NPROCS_4})
  add_executable (mmatrix.x mmatrix.F ffflush.F util.c)
  ga_add_parallel_test(mmatrix mmatrix.x)
#  add_executable (mulmatpatch.x mulmatpatch.F ffflush.F testblas.F)
#  add_executable (nb2test.x nb2test.F ffflush.F util.c)
#  ga_add_parallel_test(nb2test nb2test.x)
#  add_executable (nbtest.x nbtest.F ffflush.F util.c)
#  ga_add_parallel_test(nbtest nbtest.x)
  add_executable (ndim.x ndim.F ffflush.F util.c)
  ga_add_parallel_test(ndim ndim.x)
#  add_executable (nga-onesided.x nga-onesided.F ffflush.F util.c)
#  add_executable (nga-patch.x nga-patch.F ffflush.F util.c)
#  add_executable (nga-periodic.x nga-periodic.F ffflush.F util.c)
#  add_executable (nga-scatter.x nga-scatter.F ffflush.F)
#  add_executable (nga_test.x nga_test.F ffflush.F)
#  add_executable (ngatest.x ngatest.F ffflush.F util.c)
#  add_executable (nga-util.x nga-util.F ffflush.F)
  add_executable (patch2.x patch2.F ffflush.F)
  ga_add_parallel_test(patch2 patch2.x)
  add_executable (patch_enumf.x patch_enumf.F ffflush.F)
  ga_add_parallel_test(patch_enumf patch_enumf.x)
  add_executable (patch.x patch.F ffflush.F testblas.F)
  ga_add_parallel_test(patch patch.x)
  add_executable (perf.x perf.F ffflush.F util.c)
  ga_add_parallel_test(perf perf.x ${TEST_NPROCS_4})
  add_executable (perfmod.x perfmod.F ffflush.F util.c)
  ga_add_parallel_test(perfmod perfmod.x ${TEST_NPROCS_4})
  add_executable (perform.x perform.F ffflush.F util.c)
  ga_add_parallel_test(perform perform.x ${TEST_NPROCS_4})
  add_executable (pg2test.x pg2test.F ffflush.F util.c)
  ga_add_parallel_test(pg2test pg2test.x)
#  add_executable (pg2testmatmult.x pg2testmatmult.F ffflush.F util.c)
  add_executable (pgtest.x pgtest.F ffflush.F util.c)
  ga_add_parallel_test(pgtest pgtest.x)
#  add_executable (pgtestmatmult.x pgtestmatmult.F ffflush.F util.c)
  add_executable (random.x random.F ffflush.F util.c)
  ga_add_parallel_test(random random.x)
  add_executable (scan.x scan.F ffflush.F)
  ga_add_parallel_test(scan scan.x)
  add_executable (simple_groups_comm.x simple_groups_comm.F ffflush.F)
  ga_add_parallel_test(simple_groups_comm simple_groups_comm.x)
  add_executable (simple_groups.x simple_groups.F ffflush.F)
  ga_add_parallel_test(simple_groups simple_groups.x)
  add_executable (sparse.x sparse.F ffflush.F)
  ga_add_parallel_test(sparse sparse.x)
  add_executable (sprsmatmult.x sprsmatmult.F ffflush.F)
  ga_add_parallel_test(sprsmatmult sprsmatmult.x)
  add_executable (stride.x stride.F ffflush.F)
  ga_add_parallel_test(stride stride.x)
#  add_executable (testblas.x testblas.F ffflush.F)
  add_executable (test.x test.F ffflush.F util.c)
  ga_add_parallel_test(main_test test.x)
#  add_executable (testmatmult.x testmatmult.F ffflush.F util.c)
  add_executable (testsolve.x testsolve.F ffflush.F)
  ga_add_parallel_test(testsolve testsolve.x)
if (ENABLE_SCALAPACK)
  add_executable (testspd.x testspd.F ffflush.F)
  ga_add_parallel_test(testspd testspd.x)
  add_executable (testeig.x testeig.F ffflush.F)
  ga_add_parallel_test(testeig testeig.x)
endif()
  add_executable (types-test.x types-test.F ffflush.F util.c)
  ga_add_parallel_test(types-test types-test.x)
endif()
target_link_libraries(big.x ga)
target_link_libraries(elempatch.x ga)
if (LAPACK_FOUND)
  target_link_libraries(ga_lu.x ga)
  ga_add_parallel_test(ga_lu ga_lu.x ${TEST_NPROCS_4})
endif()
target_link_libraries(ga-mpi.x ga)
target_link_libraries(gatscat.x ga)
target_link_libraries(getmem.x ga)
#target_link_libraries(ipc.clean.x ga)
target_link_libraries(lock.x ga)
target_link_libraries(mtest.x ga)
if (NOT MSVC)
   target_link_libraries(mulmatpatchc.x ga)
endif (NOT MSVC)
target_link_libraries(normc.x ga)
target_link_libraries(ntestc.x ga)
target_link_libraries(ntestfc.x ga)
target_link_libraries(packc.x ga)
target_link_libraries(patch_enumc.x ga)
target_link_libraries(perf2.x ga)
target_link_libraries(print.x ga)
target_link_libraries(scan_addc.x ga)
target_link_libraries(scan_copyc.x ga)
target_link_libraries(simple_groups_commc.x ga)
#target_link_libraries(sprsmatvec.x ga)
target_link_libraries(testc.x ga)
target_link_libraries(testmatmultc.x ga)
target_link_libraries(testmult.x ga)
target_link_libraries(testmultrect.x ga)
target_link_libraries(testmult.x ga)
target_link_libraries(unpackc.x ga)

if (ENABLE_FORTRAN)
  target_link_libraries(bin.x ga)
#  target_link_libraries(blktest.x ga)
  target_link_libraries(d2test.x ga)
  target_link_libraries(g2test.x ga)
  target_link_libraries(g3test.x ga)
  target_link_libraries(ga_shift.x ga)
  target_link_libraries(ghosts.x ga)
  target_link_libraries(jacobi.x ga)
#  target_link_libraries(merge.x ga)
  target_link_libraries(mir_perf1.x ga)
  target_link_libraries(mir_perf2.x ga)
  target_link_libraries(mmatrix.x ga)
#  target_link_libraries(mulmatpatch.x ga)
#  target_link_libraries(nb2test.x ga)
#  target_link_libraries(nbtest.x ga)
  target_link_libraries(ndim.x ga)
#  target_link_libraries(nga-onesided.x ga)
#  target_link_libraries(nga-patch.x ga)
#  target_link_libraries(nga-periodic.x ga)
#  target_link_libraries(nga-scatter.x ga)
#  target_link_libraries(nga_test.x ga)
#  target_link_libraries(ngatest.x ga)
#  target_link_libraries(nga-util.x ga)
  target_link_libraries(patch2.x ga)
  target_link_libraries(patch_enumf.x ga)
  target_link_libraries(patch.x ga)
  target_link_libraries(perf.x ga)
  target_link_libraries(perfmod.x ga)
  target_link_libraries(perform.x ga)
  target_link_libraries(pg2test.x ga)
#  target_link_libraries(pg2testmatmult.x ga)
  target_link_libraries(pgtest.x ga)
#  target_link_libraries(pgtestmatmult.x ga)
  target_link_libraries(random.x ga)
  target_link_libraries(scan.x ga)
  target_link_libraries(simple_groups_comm.x ga)
  target_link_libraries(simple_groups.x ga)
  target_link_libraries(sparse.x ga)
  target_link_libraries(sprsmatmult.x ga)
  target_link_libraries(stride.x ga)
#  target_link_libraries(testblas.x ga)
  target_link_libraries(test.x ga)
#  target_link_libraries(testmatmult.x ga ${MPI_Fortran_LIBRARIES} ${linalg_lib})
  target_link_libraries(testsolve.x ga)
if (ENABLE_SCALAPACK)
  target_link_libraries(testspd.x ga)
  target_link_libraries(testeig.x ga)
endif()
  target_link_libraries(types-test.x ga)
endif()

=== debian/changelog ===
nwchem (7.2.3-7build1) plucky; urgency=medium

  * No-change rebuild for Python 3.13 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 03 Jan 2025 12:05:48 +0100

nwchem (7.2.3-7) unstable; urgency=medium

  * skip mpich tests on s390x (all tests currently fail).
    Closes: #1088664.

 -- Drew Parsons <dparsons@debian.org>  Mon, 30 Dec 2024 14:08:58 +0100

nwchem (7.2.3-6) unstable; urgency=medium

  * skip mpich tests on mips64el since armci is flakey there
    (armci fails its own mpich tests on mips64el)

 -- Drew Parsons <dparsons@debian.org>  Wed, 06 Nov 2024 00:12:01 +0100

nwchem (7.2.3-5) unstable; urgency=medium

  * tests have started massively failing on mips64el. Test only a
    short subset (same as riscv64).

 -- Drew Parsons <dparsons@debian.org>  Mon, 04 Nov 2024 17:49:03 +0100

nwchem (7.2.3-4) unstable; urgency=medium

  * move usr/bin/nwchem symlink to nwchem-$(ARCH_DEFAULT_MPI_IMPL) for
    each arch. Closes: #1085264.
    nwchem-*mpi* Replaces:, Breaks: nwchem (<< 7.2.3-4)
  * move nwchem man page to nwchem-data and provide symlinks
    from binary packages. Add lintian overrides from usr/bin/nwchem
    manpages in binary packages.

 -- Drew Parsons <dparsons@debian.org>  Sun, 03 Nov 2024 15:08:03 +0100

nwchem (7.2.3-3) unstable; urgency=medium

  * set nwchem-openmpi Architecture: to the specific (64-bit) arches
    listed in OPENMPI_AVAILABLE_ARCHITECTURES by mpi-default-dev

 -- Drew Parsons <dparsons@debian.org>  Tue, 17 Sep 2024 12:15:52 +0200

nwchem (7.2.3-2) unstable; urgency=medium

  * don't build or run tests for openmpi on 32-bit architectures.
    openmpi 4 is still built for these arches, but mpi-defaults
    already marks them as not supporting openmpi.

 -- Drew Parsons <dparsons@debian.org>  Tue, 17 Sep 2024 11:13:45 +0200

nwchem (7.2.3-1) unstable; urgency=medium

  * New upstream release.
  * Build-Depends: pkgconf not pkg-config
  * Standards-Version: 4.7.0

 -- Drew Parsons <dparsons@debian.org>  Mon, 16 Sep 2024 01:04:07 +0200

nwchem (7.2.2-2) unstable; urgency=medium

  * README.source: update url for DFT-D3 source
    https://www.chemie.uni-bonn.de/grimme/de/software/dft-d3
    Current version is V3.2 Rev 0.
  * reorganise debian/testsuite
    - use set -e to catch errors
    - only run half the tests on riscv64 (slow, tests time out)
    - don't run pspw_md cosmo_h3co on armhf, s390x
      (cf. upstream Issue#864)

 -- Drew Parsons <dparsons@debian.org>  Fri, 05 Apr 2024 19:03:35 +0200

=== debian/control ===
Source: nwchem
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>,
 Drew Parsons <dparsons@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               gfortran,
               bc,
               libarmci-mpi-dev (>= 0.3.1~beta-2~),
               libblas-dev,
               libglobalarrays-dev (>= 5.8.1-4~),
               liblapack-dev,
               libscalapack-mpi-dev (>= 2),
               libscalapack-mpich-dev (>= 2),
               libscalapack-openmpi-dev (>= 2) [!armel !armhf !i386 !hurd-i386 !hppa !m68k !powerpc !sh4 !x32],
               mpi-default-bin,
               mpi-default-dev,
               libmpich-dev,
               libopenmpi-dev [!armel !armhf !i386 !hurd-i386 !hppa !m68k !powerpc !sh4 !x32],
               openssh-client,
               pkgconf,
               python3-dev,
               zlib1g-dev
Standards-Version: 4.7.0
Homepage: https://nwchemgit.github.io
Vcs-Browser: https://salsa.debian.org/debichem-team/nwchem
Vcs-Git: https://salsa.debian.org/debichem-team/nwchem.git

Package: nwchem
Architecture: all
Depends: ${nwchem:Depends},
         mpi-default-bin,
         ${misc:Depends}
Description: High-performance computational chemistry software (default MPI)
 NWChem is a computational chemistry program package.  It provides methods
 which are scalable both in their ability to treat large scientific
 computational chemistry problems efficiently, and in their use of available
 parallel computing resources from high-performance parallel supercomputers to
 conventional workstation clusters.
 .
 NWChem can handle:
 .
  * Molecular electronic structure methods using gaussian
    basis functions for high-accuracy calculations of molecules
  * Pseudopotentials plane-wave electronic structure methods for calculating
    molecules, liquids, crystals, surfaces, semi-conductors or metals
  * Ab-initio and classical molecular dynamics simulations
  * Mixed quantum-classical simulations
  * Parallel scaling to thousands of processors
 .
 Features include:
  * Molecular electronic structure methods, analytic second derivatives:
   - Restricted/unrestricted Hartree-Fock (RHF, UHF)
   - Restricted Density Functional Theory (DFT) using many local,
     non-local (gradient-corrected) or hybrid (local, non-local, and HF)
     exchange-correlation potentials
  * Molecular electronic structure methods, analytic gradients:
   - Restricted open-shell Hartree-Fock (ROHF)
   - Unrestricted Density Functional Theory (DFT)
   - Second-order Moeller-Plesset perturbation theory (MP2), using RHF and UHF
     reference
   - MP2 with resolution of the identity approximation (RI-MP2)
   - Complete active space SCF (CASSCF)
   - Time-Dependent Density Functional Theory (TDDFT)
  * Molecular electronic structure methods, single-point energies:
   - MP2 spin-component scaled approach (SCS-MP2)
   - Coupled cluster singles and doubles, triples or pertubative triples
     (CCSD, CCSDT, CCSD(T)), with RHF and UHF reference
   - Configuration interaction (CISD, CISDT, and CISDTQ)
   - Second-order approximate coupled-cluster singles doubles (CC2)
   - State-specific multireference coupled cluster methods (MRCC)
     (Brillouin-Wigner (BW-MRCC) and Mukherjee (Mk-MRCC) approaches)
  * Further molecular electronic structure features:
   - Geometry optimization including transition state searches, constraints
     and minimum energy paths (via the Nudged Elastic Band (NEB) and Zero
     Temperature String methods)
   - Vibrational frequencies
   - Equation-of-motion (EOM)-CCSD, EOM-CCSDT, EOM-CCSD(T), CC2,
     Configuration-Interaction singles (CIS), time-dependent HF (TDHF) and
     TDDFT, for excited states with RHF, UHF, RDFT, or UDFT reference
   - Solvatisation using the Conductor-like screening model (COSMO) for RHF,
     ROHF and DFT, including analytical gradients
   - Hybrid calculations using the two- and three-layer ONIOM method
   - Relativistic effects via spin-free and spin-orbit one-electron
     Douglas-Kroll and zeroth-order regular approximations (ZORA) and
     one-electron spin-orbit effects for DFT via spin-orbit potentials
  * Pseudopotential plane-wave electronic structure:
   - Pseudopotential Plane-Wave (PSPW), Projector Augmented Wave (PAW) or band
     structure methods for calculating molecules, liquids, crystals, surfaces,
     semi-conductors or metals
   - Geometry/unit cell optimization including transition state searches
   - Vibrational frequencies
   - LDA, PBE96, and PBE0 exchange-correlation potentials (restricted and
     unrestricted)
   - SIC, pert-OEP, Hartree-Fock, and hybrid functionals (restricted and
     unrestricted)
   - Hamann, Troullier-Martins and Hartwigsen-Goedecker-Hutter norm-conserving
     pseudopotentials with semicore corrections
   - Wavefunction, density, electrostatic and Wannier plotting
   - Band structure and density of states generation
  * Car-Parrinello ab-initio molecular dynamics (CPMD):
   - Constant energy and constant temperature dynamics
   - Verlet algorithm for integration
   - Geometry constraints in cartesian coordinates
  * Classical molecular dynamics (MD):
   - Single configuration energy evaluation
   - Energy minimization
   - Molecular dynamics simulation
   - Free energy simulation (multistep thermodynamic perturbation (MSTP) or
     multiconfiguration thermodynamic integration (MCTI) methods with options
     of single and/or dual topologies, double wide sampling, and separation-
     shifted scaling)
   - Force fields providing effective pair potentials, first order
     polarization, self consistent polarization, smooth particle mesh Ewald
     (SPME), periodic boundary conditions and SHAKE constraints
  * Mixed quantum-classical:
   - Mixed quantum-mechanics and molecular-mechanics (QM/MM) minimizations and
     molecular dynamics simulations
   - Quantum molecular dynamics simulation by using any of the quantum
     mechanical methods capable of returning gradients.
 .
 This package provides example input scripts and depends on nwchem built for
 the default MPI implementation for the architecture.
 .
 The default MPI is openmpi for most 64-bit debian systems. OpenMPI has known
 problems running nwchem over multiple nodes. If you need to compute large
 molecules using cluster computation, you may want to use the MPICH build
 provided by nwchem-mpich instead. 32-bit arches use mpich only.

Package: nwchem-openmpi
Architecture: alpha amd64 arm64 hurd-amd64 ia64 kfreebsd-amd64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64
Multi-Arch: allowed
Depends: openmpi-bin,
         nwchem-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: nwchem (<< 7.2.3-4)
Breaks:   nwchem (<< 7.2.3-4)
Description: High-performance computational chemistry software (OpenMPI build)
 NWChem is a computational chemistry program package.  It provides methods
 which are scalable both in their ability to treat large scientific
 computational chemistry problems efficiently, and in their use of available
 parallel computing resources from high-performance parallel supercomputers to
 conventional workstation clusters.
 .
 NWChem can handle:
 .
  * Molecular electronic structure methods using gaussian
    basis functions for high-accuracy calculations of molecules
  * Pseudopotentials plane-wave electronic structure methods for calculating
    molecules, liquids, crystals, surfaces, semi-conductors or metals
  * Ab-initio and classical molecular dynamics simulations
  * Mixed quantum-classical simulations
  * Parallel scaling to thousands of processors
 .
 Features include:
  * Molecular electronic structure methods, analytic second derivatives:
   - Restricted/unrestricted Hartree-Fock (RHF, UHF)
   - Restricted Density Functional Theory (DFT) using many local,
     non-local (gradient-corrected) or hybrid (local, non-local, and HF)
     exchange-correlation potentials
  * Molecular electronic structure methods, analytic gradients:
   - Restricted open-shell Hartree-Fock (ROHF)
   - Unrestricted Density Functional Theory (DFT)
   - Second-order Moeller-Plesset perturbation theory (MP2), using RHF and UHF
     reference
   - MP2 with resolution of the identity approximation (RI-MP2)
   - Complete active space SCF (CASSCF)
   - Time-Dependent Density Functional Theory (TDDFT)
  * Molecular electronic structure methods, single-point energies:
   - MP2 spin-component scaled approach (SCS-MP2)
   - Coupled cluster singles and doubles, triples or pertubative triples
     (CCSD, CCSDT, CCSD(T)), with RHF and UHF reference
   - Configuration interaction (CISD, CISDT, and CISDTQ)
   - Second-order approximate coupled-cluster singles doubles (CC2)
   - State-specific multireference coupled cluster methods (MRCC)
     (Brillouin-Wigner (BW-MRCC) and Mukherjee (Mk-MRCC) approaches)
  * Further molecular electronic structure features:
   - Geometry optimization including transition state searches, constraints
     and minimum energy paths (via the Nudged Elastic Band (NEB) and Zero
     Temperature String methods)
   - Vibrational frequencies
   - Equation-of-motion (EOM)-CCSD, EOM-CCSDT, EOM-CCSD(T), CC2,
     Configuration-Interaction singles (CIS), time-dependent HF (TDHF) and
     TDDFT, for excited states with RHF, UHF, RDFT, or UDFT reference
   - Solvatisation using the Conductor-like screening model (COSMO) for RHF,
     ROHF and DFT, including analytical gradients
   - Hybrid calculations using the two- and three-layer ONIOM method
   - Relativistic effects via spin-free and spin-orbit one-electron
     Douglas-Kroll and zeroth-order regular approximations (ZORA) and
     one-electron spin-orbit effects for DFT via spin-orbit potentials
  * Pseudopotential plane-wave electronic structure:
   - Pseudopotential Plane-Wave (PSPW), Projector Augmented Wave (PAW) or band
     structure methods for calculating molecules, liquids, crystals, surfaces,
     semi-conductors or metals
   - Geometry/unit cell optimization including transition state searches
   - Vibrational frequencies
   - LDA, PBE96, and PBE0 exchange-correlation potentials (restricted and
     unrestricted)
   - SIC, pert-OEP, Hartree-Fock, and hybrid functionals (restricted and
     unrestricted)
   - Hamann, Troullier-Martins and Hartwigsen-Goedecker-Hutter norm-conserving
     pseudopotentials with semicore corrections
   - Wavefunction, density, electrostatic and Wannier plotting
   - Band structure and density of states generation
  * Car-Parrinello ab-initio molecular dynamics (CPMD):
   - Constant energy and constant temperature dynamics
   - Verlet algorithm for integration
   - Geometry constraints in cartesian coordinates
  * Classical molecular dynamics (MD):
   - Single configuration energy evaluation
   - Energy minimization
   - Molecular dynamics simulation
   - Free energy simulation (multistep thermodynamic perturbation (MSTP) or
     multiconfiguration thermodynamic integration (MCTI) methods with options
     of single and/or dual topologies, double wide sampling, and separation-
     shifted scaling)
   - Force fields providing effective pair potentials, first order
     polarization, self consistent polarization, smooth particle mesh Ewald
     (SPME), periodic boundary conditions and SHAKE constraints
  * Mixed quantum-classical:
   - Mixed quantum-mechanics and molecular-mechanics (QM/MM) minimizations and
     molecular dynamics simulations
   - Quantum molecular dynamics simulation by using any of the quantum
     mechanical methods capable of returning gradients.
 .
 This package provides nwchem built with OpenMPI.
 .
 OpenMPI has known problems running nwchem over multiple nodes. If you need
 to compute large molecules using cluster computation, you may want to use
 the MPICH build provided by nwchem-mpich instead.

Package: nwchem-mpich
Architecture: any
Multi-Arch: allowed
